HDU:1087 Super Jumping! Jumping! Jumping!(DP,LIS问题)

23 篇文章 0 订阅
3 篇文章 0 订阅

Super Jumping! Jumping! Jumping!

Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 65536/32768 K (Java/Others)
Total Submission(s): 31448    Accepted Submission(s): 14122


Problem Description
Nowadays, a kind of chess game called “Super Jumping! Jumping! Jumping!” is very popular in HDU. Maybe you are a good boy, and know little about this game, so I introduce it to you now.



The game can be played by two or more than two players. It consists of a chessboard(棋盘)and some chessmen(棋子), and all chessmen are marked by a positive integer or “start” or “end”. The player starts from start-point and must jumps into end-point finally. In the course of jumping, the player will visit the chessmen in the path, but everyone must jumps from one chessman to another absolutely bigger (you can assume start-point is a minimum and end-point is a maximum.). And all players cannot go backwards. One jumping can go from a chessman to next, also can go across many chessmen, and even you can straightly get to end-point from start-point. Of course you get zero point in this situation. A player is a winner if and only if he can get a bigger score according to his jumping solution. Note that your score comes from the sum of value on the chessmen in you jumping path.
Your task is to output the maximum value according to the given chessmen list.
 

Input
Input contains multiple test cases. Each test case is described in a line as follow:
N value_1 value_2 …value_N 
It is guarantied that N is not more than 1000 and all value_i are in the range of 32-int.
A test case starting with 0 terminates the input and this test case is not to be processed.
 

Output
For each case, print the maximum according to rules, and one line one case.
 

Sample Input
  
  
3 1 3 2 4 1 2 3 4 4 3 3 2 1 0
 

Sample Output
  
  
4 10 3
 

Author
lcy
 

Recommend
 


题目大意:给出你一个数列,让你从左往右找到一个数字递增的数列,使得这个数列的和最大,输出所求最大递增数列的和。


#include <stdio.h>
#include <algorithm>
using namespace std;
int a[1000];//存所输入的数字 
int w[1000];//w[i]的含义是:位于i之前的(包括i)的最大递增序列和 
int max(int q,int w)
{
	return (q>w?q:w);
}
int main()
{
	int n;
	while(scanf("%d",&n)!=EOF)
	{
		if(n==0)
		break;
		for(int i=0;i<n;i++)
		{
			scanf("%d",&a[i]);
			w[i]=a[i];
		}
		for(int i=0;i<n;i++)
		{
			for(int j=i+1;j<n;j++)
			{
				if(a[j]>a[i])//以为是递增,所以搜数字i之后比数字i大的数 
				{
					w[j]=max(w[j],w[i]+a[j]);//状态更新,举个例子模拟下就知道了 
				}
			}
		}
		sort(w,w+n);
		printf("%d\n",w[n-1]);
	}
	return 0;
}



今天又遇到了,再做一遍:

#include <cstdio>
#include <algorithm>
using namespace std;
int a[1010];
int dp[1010];//dp[i]代表以i结尾的最大子序列和 
int main()
{
	int n;
	while(scanf("%d",&n)!=EOF)
	{
		if(n==0)
		break;
		for(int i=1;i<=n;i++)
		{
			scanf("%d",&a[i]);
		}
		dp[1]=a[1];
		int ans=dp[1];//初始化ans 
		for(int i=2;i<=n;i++)
		{
			int MAX=-1;
			for(int j=1;j<i;j++)//找之前序列和最大的 
			{
				if(a[i]>a[j])//严格递增 
				{
					MAX=max(MAX,dp[j]);
				}
			}
			if(MAX!=-1)//找到之前序列和最大的,与本身相加作为本坐标的dp 
			{
				dp[i]=a[i]+MAX;
			}
			else//如果没找到符合严格递增条件的,那么这个a[i]自成一派 
			{
				dp[i]=a[i];
			}
			ans=max(ans,dp[i]);//更新ans 
		}
		printf("%d\n",ans);
	}
	return 0;
} 



评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值